Index: trunk/LMDZ.MARS/libf/phymars/co2cloud.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/co2cloud.F	(revision 1779)
+++ trunk/LMDZ.MARS/libf/phymars/co2cloud.F	(revision 1816)
@@ -663,168 +585,178 @@
          ENDDO
       ENDDO   
- 
+c------------------------------------------------------
+c      2.  Main call to the cloud schemes:
+c------------------------------------------------------
+      CALL improvedCO2clouds(ngrid,nlay,microtimestep,
+     &     pplay,pplev,zteff,subpdt,
+     &     pqeff,subpdq,subpdqcloudco2,subpdtcloudco2,
+     &     nq,tauscaling,memdMMccn,memdMMh2o,memdNNccn)
+c-----------------------------------------------------
+c      3.  Updating tendencies after cloud scheme:
+c-----------------------------------------------------
+          DO l=1,nlay
+            DO ig=1,ngrid
+               subpdt(ig,l) =
+     &              subpdt(ig,l) + subpdtcloudco2(ig,l)
+
+               subpdq(ig,l,igcm_dust_mass) =
+     &              subpdq(ig,l,igcm_dust_mass)
+     &              + subpdqcloudco2(ig,l,igcm_dust_mass)
+               subpdq(ig,l,igcm_dust_number) =
+     &              subpdq(ig,l,igcm_dust_number)
+     &              + subpdqcloudco2(ig,l,igcm_dust_number)
+
+               subpdq(ig,l,igcm_ccnco2_mass) =
+     &              subpdq(ig,l,igcm_ccnco2_mass)
+     &              + subpdqcloudco2(ig,l,igcm_ccnco2_mass)
+               subpdq(ig,l,igcm_ccnco2_number) =
+     &              subpdq(ig,l,igcm_ccnco2_number)
+     &              + subpdqcloudco2(ig,l,igcm_ccnco2_number)
+
+               subpdq(ig,l,igcm_co2_ice) =
+     &              subpdq(ig,l,igcm_co2_ice)
+     &              + subpdqcloudco2(ig,l,igcm_co2_ice)
+               subpdq(ig,l,igcm_co2) =
+     &              subpdq(ig,l,igcm_co2)
+     &              + subpdqcloudco2(ig,l,igcm_co2)
+
+               subpdq(ig,l,igcm_h2o_ice) =
+     &              subpdq(ig,l,igcm_h2o_ice)
+     &              + subpdqcloudco2(ig,l,igcm_h2o_ice)
+               subpdq(ig,l,igcm_ccn_mass) =
+     &              subpdq(ig,l,igcm_ccn_mass)
+     &              + subpdqcloudco2(ig,l,igcm_ccn_mass)
+               subpdq(ig,l,igcm_ccn_number) =
+     &              subpdq(ig,l,igcm_ccn_number)
+     &              + subpdqcloudco2(ig,l,igcm_ccn_number)
+            ENDDO
+         ENDDO
       ENDDO                     ! of DO microstep=1,imicro
       
-c-------------------------------------------------------------------
-c   6.  Compute final tendencies after time loop:
+c------------------------------------------------
+c   Compute final tendencies after time loop:
 c------------------------------------------------
 c CO2 flux at surface (kg.m-2.s-1)
       do ig=1,ngrid 
-         pdqs_sedco2(ig)=pdqs_sedco2(ig)/real(imicro)
+         pdqs_sedco2(ig)=pdqs_sedco2(ig)/real(imicroco2)
       enddo
-
 c------ Temperature tendency pdtcloud
        DO l=1,nlay
          DO ig=1,ngrid
              pdtcloudco2(ig,l) =
-     &         subpdt(ig,l)/real(imicro)-pdt(ig,l)
+     &         subpdt(ig,l)/real(imicroco2)-pdt(ig,l)
           ENDDO
        ENDDO
-
 c------ Tracers tendencies pdqcloud
        DO l=1,nlay
-         DO ig=1,ngrid
-         
-            pdqcloudco2(ig,l,igcm_co2_ice) = 
-     &        subpdq(ig,l,igcm_co2_ice)/real(imicro)
-     &       - pdq(ig,l,igcm_co2_ice)
-            pdqcloudco2(ig,l,igcm_co2) = 
-     &        subpdq(ig,l,igcm_co2)/real(imicro)
-     &       - pdq(ig,l,igcm_co2)
-            pdqcloudco2(ig,l,igcm_h2o_ice) = 
-     &        subpdq(ig,l,igcm_h2o_ice)/real(imicro)
-     &       - pdq(ig,l,igcm_h2o_ice)
-         ENDDO
+          DO ig=1,ngrid        
+             pdqcloudco2(ig,l,igcm_co2_ice) = 
+     &            subpdq(ig,l,igcm_co2_ice)/real(imicroco2)
+     &            - pdq(ig,l,igcm_co2_ice)
+             pdqcloudco2(ig,l,igcm_co2) = 
+     &            subpdq(ig,l,igcm_co2)/real(imicroco2)
+     &            - pdq(ig,l,igcm_co2)
+             pdqcloudco2(ig,l,igcm_h2o_ice) = 
+     &            subpdq(ig,l,igcm_h2o_ice)/real(imicroco2)
+     &            - pdq(ig,l,igcm_h2o_ice)
+          ENDDO
        ENDDO
-
-        DO l=1,nlay
-         DO ig=1,ngrid
-            pdqcloudco2(ig,l,igcm_ccnco2_mass) = 
-     &        subpdq(ig,l,igcm_ccnco2_mass)/real(imicro)
-     &       - pdq(ig,l,igcm_ccnco2_mass)
-            pdqcloudco2(ig,l,igcm_ccnco2_number) = 
-     &        subpdq(ig,l,igcm_ccnco2_number)/real(imicro)
-     &       - pdq(ig,l,igcm_ccnco2_number)
-            pdqcloudco2(ig,l,igcm_ccn_mass) = 
-     &        subpdq(ig,l,igcm_ccn_mass)/real(imicro)
-     &       - pdq(ig,l,igcm_ccn_mass)
-            pdqcloudco2(ig,l,igcm_ccn_number) = 
-     &        subpdq(ig,l,igcm_ccn_number)/real(imicro)
-     &       - pdq(ig,l,igcm_ccn_number)
+       DO l=1,nlay
+          DO ig=1,ngrid
+             pdqcloudco2(ig,l,igcm_ccnco2_mass) = 
+     &            subpdq(ig,l,igcm_ccnco2_mass)/real(imicroco2)
+     &            - pdq(ig,l,igcm_ccnco2_mass)
+             pdqcloudco2(ig,l,igcm_ccnco2_number) = 
+     &            subpdq(ig,l,igcm_ccnco2_number)/real(imicroco2)
+     &            - pdq(ig,l,igcm_ccnco2_number)
+             pdqcloudco2(ig,l,igcm_ccn_mass) = 
+     &            subpdq(ig,l,igcm_ccn_mass)/real(imicroco2)
+     &            - pdq(ig,l,igcm_ccn_mass)
+             pdqcloudco2(ig,l,igcm_ccn_number) = 
+     &            subpdq(ig,l,igcm_ccn_number)/real(imicroco2)
+     &            - pdq(ig,l,igcm_ccn_number)
+          ENDDO
+       ENDDO
+       DO l=1,nlay
+          DO ig=1,ngrid
+             pdqcloudco2(ig,l,igcm_dust_mass) = 
+     &            subpdq(ig,l,igcm_dust_mass)/real(imicroco2)
+     &            - pdq(ig,l,igcm_dust_mass)
+             pdqcloudco2(ig,l,igcm_dust_number) = 
+     &            subpdq(ig,l,igcm_dust_number)/real(imicroco2)
+     &            - pdq(ig,l,igcm_dust_number)
+          ENDDO
+       ENDDO
+c-------Due to stepped entry, other processes tendencies can add up to negative values
+c-------Therefore, enforce positive values and conserve mass
+       DO l=1,nlay
+          DO ig=1,ngrid
+             IF ((pqeff(ig,l,igcm_ccnco2_number) + 
+     &            ptimestep* (pdq(ig,l,igcm_ccnco2_number) + 
+     &            pdqcloudco2(ig,l,igcm_ccnco2_number))
+     &            .lt. 1.)
+     &            .or. (pqeff(ig,l,igcm_ccnco2_mass) + 
+     &            ptimestep* (pdq(ig,l,igcm_ccnco2_mass) + 
+     &            pdqcloudco2(ig,l,igcm_ccnco2_mass))
+     &            .lt. 1.e-20)) THEN
+                pdqcloudco2(ig,l,igcm_ccnco2_number) =
+     &               - pqeff(ig,l,igcm_ccnco2_number)/ptimestep 
+     &               - pdq(ig,l,igcm_ccnco2_number)+1.
+                pdqcloudco2(ig,l,igcm_dust_number) =  
+     &               -pdqcloudco2(ig,l,igcm_ccnco2_number)
+                pdqcloudco2(ig,l,igcm_ccnco2_mass) =
+     &               - pqeff(ig,l,igcm_ccnco2_mass)/ptimestep
+     &               - pdq(ig,l,igcm_ccnco2_mass)+1.e-20
+                pdqcloudco2(ig,l,igcm_dust_mass) = 
+     &               -pdqcloudco2(ig,l,igcm_ccnco2_mass)
+             ENDIF
+          ENDDO
+       ENDDO
+       DO l=1,nlay
+          DO ig=1,ngrid
+             IF ( (pqeff(ig,l,igcm_dust_number) + 
+     &            ptimestep* (pdq(ig,l,igcm_dust_number) + 
+     &            pdqcloudco2(ig,l,igcm_dust_number)) .le. 1.)
+     &            .or. (pqeff(ig,l,igcm_dust_mass)+ 
+     &            ptimestep* (pdq(ig,l,igcm_dust_mass) + 
+     &            pdqcloudco2(ig,l,igcm_dust_mass))
+     &            .le. 1.e-20)) then                  
+                pdqcloudco2(ig,l,igcm_dust_number) =
+     &               - pqeff(ig,l,igcm_dust_number)/ptimestep 
+     &               - pdq(ig,l,igcm_dust_number)+1.
+                pdqcloudco2(ig,l,igcm_ccnco2_number) =  
+     &               -pdqcloudco2(ig,l,igcm_dust_number)
+                pdqcloudco2(ig,l,igcm_dust_mass) =
+     &               - pqeff(ig,l,igcm_dust_mass)/ptimestep
+     &               - pdq(ig,l,igcm_dust_mass) +1.e-20
+                pdqcloudco2(ig,l,igcm_ccnco2_mass) = 
+     &               -pdqcloudco2(ig,l,igcm_dust_mass)
+             ENDIF
+          ENDDO
+       ENDDO
+        !pq+ptime*(pdq+pdqc)=1 ! pdqc=1-pq/ptime-pdq      
+       DO l=1,nlay
+          DO ig=1,ngrid
+             IF (pqeff(ig,l,igcm_co2_ice) + ptimestep*
+     &       (pdq(ig,l,igcm_co2_ice) + pdqcloudco2(ig,l,igcm_co2_ice)) 
+     &       .lt. 1.e-15) THEN
+           pdqcloudco2(ig,l,igcm_co2_ice) = 
+     &     - pqeff(ig,l,igcm_co2_ice)/ptimestep-pdq(ig,l,igcm_co2_ice)
+           pdqcloudco2(ig,l,igcm_co2) = -pdqcloudco2(ig,l,igcm_co2_ice)
+          ENDIF    
+          IF (pqeff(ig,l,igcm_co2) + ptimestep*
+     &       (pdq(ig,l,igcm_co2) + pdqcloudco2(ig,l,igcm_co2)) 
+     &       .lt. 0.1) THEN
+           pdqcloudco2(ig,l,igcm_co2) = 
+     &     - pqeff(ig,l,igcm_co2)/ptimestep - pdq(ig,l,igcm_co2)
+           pdqcloudco2(ig,l,igcm_co2_ice)= -pdqcloudco2(ig,l,igcm_co2)
+          ENDIF
          ENDDO
         ENDDO
 
-       
-        DO l=1,nlay
-         DO ig=1,ngrid
-            pdqcloudco2(ig,l,igcm_dust_mass) = 
-     &        subpdq(ig,l,igcm_dust_mass)/real(imicro)
-     &       - pdq(ig,l,igcm_dust_mass)
-            pdqcloudco2(ig,l,igcm_dust_number) = 
-     &        subpdq(ig,l,igcm_dust_number)/real(imicro)
-     &       - pdq(ig,l,igcm_dust_number)
-         ENDDO
-        ENDDO
-
-c------- Due to stepped entry, other processes tendencies can add up to negative values
-c------- Therefore, enforce positive values and conserve mass
-
-
-
-        DO l=1,nlay
-           DO ig=1,ngrid
-              IF ((pqeff(ig,l,igcm_ccnco2_number) + 
-     &             ptimestep* (pdq(ig,l,igcm_ccnco2_number) + 
-     &             pdqcloudco2(ig,l,igcm_ccnco2_number))
-     &             .lt. 1.e-20)
-     &             .or. (pqeff(ig,l,igcm_ccnco2_mass) + 
-     &             ptimestep* (pdq(ig,l,igcm_ccnco2_mass) + 
-     &             pdqcloudco2(ig,l,igcm_ccnco2_mass))
-     &             .lt. 1.e-30)) THEN
-                 
-                 pdqcloudco2(ig,l,igcm_ccnco2_number) =
-     &                - pqeff(ig,l,igcm_ccnco2_number)/ptimestep 
-     &                - pdq(ig,l,igcm_ccnco2_number)+1.e-20
-                 pdqcloudco2(ig,l,igcm_dust_number) =  
-     &                -pdqcloudco2(ig,l,igcm_ccnco2_number)
-                 pdqcloudco2(ig,l,igcm_ccnco2_mass) =
-     &                - pqeff(ig,l,igcm_ccnco2_mass)/ptimestep
-     &                - pdq(ig,l,igcm_ccnco2_mass)+1.e-30
-                 pdqcloudco2(ig,l,igcm_dust_mass) = 
-     &                -pdqcloudco2(ig,l,igcm_ccnco2_mass)
-
-              ENDIF
-           ENDDO
-        ENDDO
-        
-
-      
-        DO l=1,nlay
-           DO ig=1,ngrid
-              IF ( (pqeff(ig,l,igcm_dust_number) + 
-     &             ptimestep* (pdq(ig,l,igcm_dust_number) + 
-     &             pdqcloudco2(ig,l,igcm_dust_number)) .le. 1.e-30)
-     &             .or. (pqeff(ig,l,igcm_dust_mass)+ 
-     &             ptimestep* (pdq(ig,l,igcm_dust_mass) + 
-     &             pdqcloudco2(ig,l,igcm_dust_mass))
-     &             .le. 1.e-30)) then 
-                 
-                 pdqcloudco2(ig,l,igcm_dust_number) =
-     &                - pqeff(ig,l,igcm_dust_number)/ptimestep 
-     &                - pdq(ig,l,igcm_dust_number)+1.e-30
-                 pdqcloudco2(ig,l,igcm_ccnco2_number) =  
-     &                  -pdqcloudco2(ig,l,igcm_dust_number)
-                 pdqcloudco2(ig,l,igcm_dust_mass) =
-     &                  - pqeff(ig,l,igcm_dust_mass)/ptimestep
-     &                  - pdq(ig,l,igcm_dust_mass) +1.e-30
-                 pdqcloudco2(ig,l,igcm_ccnco2_mass) = 
-     &                -pdqcloudco2(ig,l,igcm_dust_mass)
-
-              ENDIF
-           ENDDO
-        ENDDO
-        !pq+ptime*(pdq+pdqc)=1 ! pdqc=1-pq/ptime-pdq
-c$$$
-c$$$      
-c$$$        DO l=1,nlay
-c$$$         DO ig=1,ngrid
-c$$$          IF (pq(ig,l,igcm_co2_ice) + ptimestep*
-c$$$     &       (pdq(ig,l,igcm_co2_ice) + pdqcloudco2(ig,l,igcm_co2_ice)) 
-c$$$     &       .lt. 1.e-30) THEN
-c$$$           pdqcloudco2(ig,l,igcm_co2_ice) = 
-c$$$     &     - pq(ig,l,igcm_co2_ice)/ptimestep - pdq(ig,l,igcm_co2_ice)
-c$$$           pdqcloudco2(ig,l,igcm_co2) = -pdqcloudco2(ig,l,igcm_co2_ice)
-c$$$           !write(*,*) "WARNING CO2 ICE in co2cloud.F"
-c$$$
-c$$$          ENDIF    
-c$$$          IF (pq(ig,l,igcm_co2) + ptimestep*
-c$$$     &       (pdq(ig,l,igcm_co2) + pdqcloudco2(ig,l,igcm_co2)) 
-c$$$     &       .lt. 0.5) THEN
-c$$$           pdqcloudco2(ig,l,igcm_co2) = 
-c$$$     &     - pdq(ig,l,igcm_co2_ice) !- pdq(ig,l,igcm_co2)
-c$$$c           pdqcloudco2(ig,l,igcm_co2_ice) = -pdqcloudco2(ig,l,igcm_co2)
-c$$$           pdqcloudco2(ig,l,igcm_co2_ice) = 
-c$$$     &     - pq(ig,l,igcm_co2_ice)/ptimestep - pdq(ig,l,igcm_co2_ice)      
-c$$$          ! write(*,*) "WARNING CO2 in co2cloud.F"
-c$$$          ENDIF
-c$$$         ENDDO
-c$$$        ENDDO
-c$$$  
-        
+c Update clouds parameters values in the cloud fraction (for output)
         DO l=1, nlay
            DO ig=1,ngrid
 
-c     call updaterice_microco2(
-c     &    pq(ig,l,igcm_co2_ice) +                    ! ice mass
-c     &   (pdq(ig,l,igcm_co2_ice) +                   ! ice mass
-c     &    pdqcloudco2(ig,l,igcm_co2_ice))*ptimestep,    ! ice mass
-c     &    pq(ig,l,igcm_ccnco2_mass) +                   ! ccn mass
-c     &   (pdq(ig,l,igcm_ccnco2_mass) +                  ! ccn mass
-c     &    pdqcloudco2(ig,l,igcm_ccnco2_mass))*ptimestep,   ! ccn mass
-c     &    pq(ig,l,igcm_ccnco2_number) +                 ! ccn number
-c     &   (pdq(ig,l,igcm_ccnco2_number) +                ! ccn number
-c     &    pdqcloudco2(ig,l,igcm_ccnco2_number))*ptimestep, ! ccn number
-c     &    tauscaling(ig),riceco2(ig,l),rhocloudco2(ig,l))
-c        write(*,*) "in co2clouds, riceco2(ig,l)= ",riceco2(ig,l)
               Niceco2=pqeff(ig,l,igcm_co2_ice) +                   
      &             (pdq(ig,l,igcm_co2_ice) + 
@@ -835,144 +767,37 @@
               Nccnco2=max((pqeff(ig,l,igcm_ccnco2_number) +                 
      &             (pdq(ig,l,igcm_ccnco2_number) +               
-     &             pdqcloudco2(ig,l,igcm_ccnco2_number))*ptimestep)*
-     &             tauscaling(ig),1.e-30)
+     &             pdqcloudco2(ig,l,igcm_ccnco2_number))*ptimestep)
+     &             ,1.e-30)
               Qccnco2=max((pqeff(ig,l,igcm_ccnco2_mass) +                 
      &             (pdq(ig,l,igcm_ccnco2_mass) +               
-     &             pdqcloudco2(ig,l,igcm_ccnco2_mass))*ptimestep)*
-     &             tauscaling(ig),1.e-30)
+     &             pdqcloudco2(ig,l,igcm_ccnco2_mass))*ptimestep)
+     &             ,1.e-30)
               
-              if (Nccnco2 .lt. 0.1) then 
-                 rdust(ig,l)=1.e-10
-              else
-        
-                 rdust(ig,l)= Qccnco2
-     &                *0.75/pi/rho_dust
-     &                / Nccnco2
-                 rdust(ig,l)= rdust(ig,l)**(1./3.)            
-                 rdust(ig,l)=max(1.e-10,rdust(ig,l))
-c     rdust(ig,l)=min(5.e-6,rdust(ig,l))
-              endif
               myT=zteff(ig,l)+(pdt(ig,l)+pdtcloudco2(ig,l))*ptimestep
               rho_ice_co2T(ig,l)=1000.*(1.72391-2.53e-4* 
      &             myT-2.87e-6* myT* myT)
               rho_ice_co2=rho_ice_co2T(ig,l)
-
-              lw = l0 + l1 * myT + l2 *myT**2 + 
-     &             l3 * myT**3 + l4 * myT**4 !J.kg-1
-
-              riceco2(ig,l)=(Niceco2*3.0/
-     &             (4.0*rho_ice_co2*pi*Nccnco2)
-     &             +rdust(ig,l)*rdust(ig,l)
-     &             *rdust(ig,l) )**(1.0/3.0)
-c    &      .or. (riceco2(ig,l) .le. rdust(ig,l))
-              if ( (Niceco2 .le. 1.e-25).or. (Nccnco2 .le. 0.1) )THEN !anciennement 200
-c           riceco2(ig,l)=0.
-
-c     &       .or. (Nccnco2 .le. 1.)
-c        endif
-!Flux chaleur latente <0 quand sublimation  
-
-           pdtcloudco2(ig,l)= pdtcloudco2(ig,l)-Niceco2*lw/cpp/ptimestep
-c$$$  !NO CLOUD : RESET TRACERS AND CONSERVE MASS
-c           if (pq(ig,l,igcm_co2_ice)+(pdq(ig,l,igcm_co2_ice)+
-c     &          pdqcloudco2(ig,l,igcm_co2_ice))*ptimestep .le. 0.) then
-c              pdqcloudco2(ig,l,igcm_co2)=0.
-c              pdqcloudco2(ig,l,igcm_co2_ice)=0.
-c           else
-             pdqcloudco2(ig,l,igcm_co2_ice)=-1.*pqeff(ig,l,igcm_co2_ice)
-     &             /ptimestep-pdq(ig,l,igcm_co2_ice)
-              pdqcloudco2(ig,l,igcm_co2)=-1.*
-     &             pdqcloudco2(ig,l,igcm_co2_ice)
-c           endif
-!     Reverse h2o ccn and ices into h2o tracers
-           if (memdMMccn(ig,l) .gt. 0) then
-              pdqcloudco2(ig,l,igcm_ccn_mass)=memdMMccn(ig,l)/ptimestep
-           else
-              memdMMccn(ig,l)=0.
-              pdqcloudco2(ig,l,igcm_ccn_mass)=0.
-           endif 
-           if (memdNNccn(ig,l) .gt. 0) then
-             pdqcloudco2(ig,l,igcm_ccn_number)=memdNNccn(ig,l)/ptimestep
-           else 
-              memdNNccn(ig,l)=0.
-              pdqcloudco2(ig,l,igcm_ccn_number)=0.
-           endif
-           if (memdMMh2o(ig,l) .gt. 0) then
-              pdqcloudco2(ig,l,igcm_h2o_ice)=memdMMh2o(ig,l)/ptimestep
-           else
-              memdMMh2o(ig,l)=0.
-              pdqcloudco2(ig,l,igcm_h2o_ice)=0.
-           endif
-c           if (pq(ig,l,igcm_ccnco2_mass)+(pdq(ig,l,igcm_ccnco2_mass)+
-c     &          pdqcloudco2(ig,l,igcm_ccnco2_mass))*ptimestep 
-c     &          .le. 1.e-30) then
-c              pdqcloudco2(ig,l,igcm_ccnco2_mass)=0.
-c              pdqcloudco2(ig,l,igcm_ccnco2_number)=0.
-c              pdqcloudco2(ig,l,igcm_co2)=0.
-c              pdqcloudco2(ig,l,igcm_co2_ice)=0.
-c           else
-              pdqcloudco2(ig,l,igcm_ccnco2_mass)=
-     &             -1.*pqeff(ig,l,igcm_ccnco2_mass)
-     &             /ptimestep-pdq(ig,l,igcm_ccnco2_mass)
-c           endif
-c           if (pq(ig,l,igcm_ccnco2_number)+
-c     &          (pdq(ig,l,igcm_ccnco2_number)+
-c     &          pdqcloudco2(ig,l,igcm_ccnco2_number))
-c     &          *ptimestep.le. 1.e-30) 
-c     &          then
-c              pdqcloudco2(ig,l,igcm_ccnco2_mass)=0.
-c              pdqcloudco2(ig,l,igcm_ccnco2_number)=0.
-c              pdqcloudco2(ig,l,igcm_co2)=0.
-c              pdqcloudco2(ig,l,igcm_co2_ice)=0.
-c           else
-              pdqcloudco2(ig,l,igcm_ccnco2_number)=
-     &             -1.*pqeff(ig,l,igcm_ccnco2_number)
-     &             /ptimestep-pdq(ig,l,igcm_ccnco2_number)
-c           endif
-c           if (pq(ig,l,igcm_dust_number)+
-c     &          (pdq(ig,l,igcm_dust_number)+
-c     &          pdqcloudco2(ig,l,igcm_dust_number))
-c     &          *ptimestep.le. 1.e-30) 
-c     &          then
-c              pdqcloudco2(ig,l,igcm_dust_number)=0.
-c              pdqcloudco2(ig,l,igcm_dust_mass)=0.
-c           else
-              pdqcloudco2(ig,l,igcm_dust_number)=
-     &             pqeff(ig,l,igcm_ccnco2_number)
-     &             /ptimestep+pdq(ig,l,igcm_ccnco2_number)
-     &             -memdNNccn(ig,l)/ptimestep
-c           endif
-c           if (pq(ig,l,igcm_dust_mass)+
-c     &          (pdq(ig,l,igcm_dust_mass)+
-c     &          pdqcloudco2(ig,l,igcm_dust_mass))
-c     &          *ptimestep .le. 1.e-30) 
-c     &          then
-c              pdqcloudco2(ig,l,igcm_dust_number)=0.
-c              pdqcloudco2(ig,l,igcm_dust_mass)=0.
-c           else
-              pdqcloudco2(ig,l,igcm_dust_mass)=
-     &             pqeff(ig,l,igcm_ccnco2_mass)
-     &             /ptimestep+pdq(ig,l,igcm_ccnco2_mass)
-     &             -(memdMMh2o(ig,l)+memdMMccn(ig,l))/ptimestep
-c           endif
-           memdMMccn(ig,l)=0.
-           memdMMh2o(ig,l)=0.
-           memdNNccn(ig,l)=0.
-           riceco2(ig,l)=0. 
-        endif
+c             rho_ice_co2 is shared by tracer_mod and used in updaterice
+c     Compute particle size
+              call updaterice_microco2(Niceco2,
+     &             Qccnco2,Nccnco2,
+     &             tauscaling(ig),riceco2(ig,l),rhocloudco2(ig,l))
+              
+              if ( (Niceco2 .le. 1.e-25 .or. 
+     &             Nccnco2*tauscaling(ig) .le. 1.) )THEN
+                 riceco2(ig,l)=0.
+              endif
 c     Compute opacities
-      No=Nccnco2
-      Rn=-log(riceco2(ig,l))
-      n_derf = erf( (rb_cldco2(1)+Rn) *dev2)
-      Qext1bins2(ig,l)=0.
-      do i = 1, nbinco2_cld !Qext below 50 is negligible
-         n_aer(i) = -0.5 * No * n_derf !! this ith previously computed
-         n_derf = derf((rb_cldco2(i+1)+Rn) *dev2)
-         n_aer(i) = n_aer(i) + 0.5 * No * n_derf
-         Qext1bins2(ig,l)=Qext1bins2(ig,l)+Qext1bins(i)*n_aer(i)
-      enddo
-      !l'opacité de la case ig est la somme sur l de Qext1bins2
-   
-   
+           No=Nccnco2*tauscaling(ig)
+           Rn=-dlog(riceco2(ig,l))
+           n_derf = derf( (rb_cldco2(1)+Rn) *dev2)
+           Qext1bins2(ig,l)=0.
+           do i = 1, nbinco2_cld 
+              n_aer(i) = -0.5 * No * n_derf !! this ith previously computed
+              n_derf = derf((rb_cldco2(i+1)+Rn) *dev2)
+              n_aer(i) = n_aer(i) + 0.5 * No * n_derf
+              Qext1bins2(ig,l)=Qext1bins2(ig,l)+Qext1bins(i)*n_aer(i)
+           enddo
+     
       !update rice water
         call updaterice_micro(
@@ -988,5 +813,4 @@
      &    tauscaling(ig),rice(ig,l),rhocloud(ig,l))
           
-
         call updaterdust(
      &    pqeff(ig,l,igcm_dust_mass) +                   ! dust mass
@@ -999,51 +823,19 @@
 
          ENDDO
-       ENDDO
-       tau1mic(:)=0.
-       do l=1,nlay
-          do ig=1,ngrid 
-             tau1mic(ig)=tau1mic(ig)+Qext1bins2(ig,l)
-          enddo
-      enddo
-
-c$$$
-c$$$      if (riceco2(725,22) .ge. 1.e-10) then
-c$$$        
-c$$$         write(*,*) 'DIAGJA co2 ',pqeff(725,22,igcm_co2) +                   
-c$$$     &        (pdq(725,22,igcm_co2) + 
-c$$$     &        pdqcloudco2(725,22,igcm_co2))*ptimestep
-c$$$         write(*,*) 'DIAGJA co2_ice',pqeff(725,22,igcm_co2_ice) +
-c$$$     &        (pdq(725,22,igcm_co2_ice) + 
-c$$$     &        pdqcloudco2(725,22,igcm_co2_ice))*ptimestep
-c$$$         
-c$$$         write(*,*) 'DIAGJA riceco2',riceco2(725,22)
-c$$$         write(*,*) 'DIAGJA T',zteff(725,22) +
-c$$$     &        (pdt(725,22) + pdtcloudco2(725,22))*ptimestep
-c$$$         write(*,*) 'DIAG pdtcloud',pdtcloudco2(725,22)*ptimestep
-c$$$         write(*,*) 'DIAGJA ccnNco2',pqeff(725,22,igcm_ccnco2_number)+
-c$$$     &        (pdq(725,22,igcm_ccnco2_number) + 
-c$$$     &        pdqcloudco2(725,22,igcm_ccnco2_number))*ptimestep
-c$$$         
-c$$$         write(*,*) 'DIAGJA dustN',pqeff(725,22,igcm_dust_number) +
-c$$$     &        (pdq(725,22,igcm_dust_number) + 
-c$$$     &        pdqcloudco2(725,22,igcm_dust_number))*ptimestep
-c$$$      ENDIF
-c$$$      
-
-
+       ENDDO 
      
 c     A correction if a lot of subliming CO2 fills the 1st layer FF04/2005
 c     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 c     Then that should not affect the ice particle radius
-      do ig=1,ngrid
-        if(pdpsrf(ig)*ptimestep.gt.0.9*(pplev(ig,1)-pplev(ig,2)))then
-          if(pdpsrf(ig)*ptimestep.gt.0.9*(pplev(ig,1)-pplev(ig,3)))
-     &    riceco2(ig,2)=riceco2(ig,3) 
-          riceco2(ig,1)=riceco2(ig,2)
+       
+       do ig=1,ngrid
+          if(pdpsrf(ig)*ptimestep.gt.0.9*(pplev(ig,1)-pplev(ig,2)))then
+             if(pdpsrf(ig)*ptimestep.gt.0.9*(pplev(ig,1)-pplev(ig,3)))
+     &       riceco2(ig,2)=riceco2(ig,3) 
+             riceco2(ig,1)=riceco2(ig,2)
         end if
       end do
        
-       
-       DO l=1,nlay
+      DO l=1,nlay
          DO ig=1,ngrid
            rsedcloud(ig,l)=max(rice(ig,l)*
@@ -1071,5 +863,4 @@
      &            pdqcloudco2(ig,l,igcm_co2))*ptimestep)*
      &            (mmean(ig,l)/44.01)*pplay(ig,l)/zqsatco2(ig,l)
-             !write(*,*) "In CO2 pt,sat ",pt(ig,l),satuco2(ig,l)
             enddo
          enddo
@@ -1097,32 +888,30 @@
      &             pdqcloudco2(ig,l,igcm_co2)*cloudfrac(ig,l)
                   pdtcloudco2(ig,l)=pdtcloudco2(ig,l)*cloudfrac(ig,l)
+                  Qext1bins2(ig,l)=Qext1bins2(ig,l)*cloudfrac(ig,l)
                ENDDO
             ENDDO   
          ENDIF
-
+!l'opacité de la case ig est la somme sur l de Qext1bins2: Est-ce-vrai?
+         tau1mic(:)=0.
+         do l=1,nlay
+            do ig=1,ngrid 
+               tau1mic(ig)=tau1mic(ig)+Qext1bins2(ig,l)
+            enddo
+         enddo
+!Outputs:
+         call WRITEDIAGFI(ngrid,"SatIndex","SatIndex"," ",3,
+     &        SatIndex)
          call WRITEDIAGFI(ngrid,"satuco2","vap in satu","kg/kg",3,
      &        satuco2)
          call WRITEdiagfi(ngrid,"riceco2","ice radius","m"
-     &        ,3,riceco2)
-!     or output in diagfi.nc (for testphys1d)
-c         call WRITEDIAGFI(ngrid,'ps','Surface pressure','Pa',0,ps)
-c         call WRITEDIAGFI(ngrid,'temp','Temperature ',
-c     &                       'K JA',1,pt)
+     &        ,3,riceco2)         
+         call WRITEdiagfi(ngrid,"cloudfrac","co2 cloud fraction"
+     &        ," ",3,cloudfrac)
+         call WRITEdiagfi(ngrid,"rsedcloudco2","rsed co2"
+     &        ,"m",3,rsedcloudco2)
+         call WRITEdiagfi(ngrid,"Tau3D1mic"," co2 ice opacities"
+     &        ," ",3,Qext1bins2)
+         call WRITEdiagfi(ngrid,"tau1mic","co2 ice opacity 1 micron"
+     &        ," ",2,tau1mic)
          
-      call WRITEdiagfi(ngrid,"rsedcloudco2","rsed co2","m",3,
-     &   rsedcloudco2)
-      
-      call WRITEdiagfi(ngrid,"tau1mic","co2 ice opacity 1 micron"," ",2,
-     &   tau1mic)
-      call WRITEdiagfi(ngrid,"cloudfrac","co2 cloud fraction"," ",3,
-     &   cloudfrac)
-! used for rad. transfer calculations
-! nuice is constant because a lognormal distribution is prescribed
-c      nuice(1:ngrid,1:nlay)=nuice_ref 
-
-
-
-c=======================================================================
-
-      END
- 
+         END
